unsupported = false

FLOOD_WATER = 0
FLOOD_LAVA  = 1
FLOOD_SAND  = 2
FLOOD_MUD   = 3

FLOOD_BONUS_LEVELS = 0
FLOOD_LEVEL_COUNT = 0

LEVEL_LOBBY = LEVEL_CASTLE_GROUNDS
LEVEL_CTT = LEVEL_SA
LEVEL_CS = level_register('level_cs_entry', COURSE_NONE, 'Crystal Slide', 'Crystal Slide', 28000, 0x28, 0x28, 0x28)
LEVEL_MC = level_register('level_mc_entry', COURSE_NONE, 'Mountain Chog', 'Mountain Chog', 28000, 0x28, 0x28, 0x28)
LEVEL_CONSTRUCT = level_register('level_co_entry', COURSE_NONE, 'gm_construct', 'gm_construct', 28000, 0x28, 0x28, 0x28)
LEVEL_BIRDSLAIR = level_register('level_birdslair_entry', COURSE_NONE, "Bird's lair", "Bird's lair", 28000, 0x28, 0x28, 0x28)

GAME_VANILLA = 0
GAME_STAR_ROAD = 1

game = GAME_VANILLA

--- @class FloodLevel
--- @field public level          integer
--- @field public name           string
--- @field public goalPos        Vec3f
--- @field public speed          number
--- @field public area           integer
--- @field public type           integer
--- @field public customStartPos Vec3f

--- @type FloodLevel[]
gLevels = {}
-- localize functions to improve performance
local table_insert,djui_popup_create = table.insert,djui_popup_create

local function flood_define_level(bonus, level, name, goalPos, speed, area, type, customStartPos)
    table_insert(gLevels, { level = level, name = name, goalPos = goalPos, speed = speed, area = area, type = type, customStartPos = customStartPos })

    if bonus then FLOOD_BONUS_LEVELS = FLOOD_BONUS_LEVELS + 1 end
    FLOOD_LEVEL_COUNT = FLOOD_LEVEL_COUNT + 1
end
_G.flood_define_level = flood_define_level

local function flood_load_vanilla_levels()
    game = GAME_VANILLA

    --                 bonus  level                 name              goal position                                    speed area type         custom start pos
    flood_define_level(false, LEVEL_BOB,            "bob",            { x =  3304,  y = 4242,  z = -4603, a =  0x0000 }, 2.5,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_WF,             "wf",             { x =  414,   y = 5325,  z = -20,   a =  0x0000 }, 4.0,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_CCM,            "ccm",            { x = -478,   y = 3471,  z = -964,  a =  0x0000 }, 5.0,  1,   FLOOD_WATER, { x = 3336, y = -3800, z =  0, a = 0x0000 })
    flood_define_level(false, LEVEL_BITDW,          "bitdw",          { x =  6772,  y = 2867,  z =  0,    a = -0x4000 }, 4.0,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_BBH,            "bbh",            { x =  655,   y = 3277,  z =  244,  a =  0x8000 }, 3.5,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_HMC,            "hmc",            { x = -4163,  y = 2355,  z = -2544, a =  0x0000 }, 5.0,  1,   FLOOD_WATER, { x = -3538, y = -3979, z = 3568, a = 0x8000 })
    flood_define_level(false, LEVEL_LLL,            "lll-volcano",    { x =  2523,  y = 3591,  z = -898,  a = -0x8000 }, 3.5,  2,   FLOOD_LAVA,  nil)
    flood_define_level(false, LEVEL_SSL,            "ssl-pyramid",    { x =  512,   y = 4815,  z = -551,  a =  0x0000 }, 3.0,  2,   FLOOD_SAND,  nil)
    flood_define_level(false, LEVEL_WDW,            "wdw",            { x =  1467,  y = 4096,  z =  93,   a = -0x4000 }, 4.0,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_TTM,            "ttm",            { x =  1053,  y = 2309,  z =  305,  a =  0x0000 }, 3.0,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_THI,            "thi",            { x = -12,    y = 3891,  z = -1556, a =  0x0000 }, 4.0,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_TTC,            "ttc",            { x =  2208,  y = 7051,  z =  2217, a =  0x0000 }, 4.0,  1,   FLOOD_WATER, nil)
    flood_define_level(false, LEVEL_BITS,           "bits",           { x =  369,   y = 6552,  z = -6000, a =  0x0000 }, 4.5,  1,   FLOOD_LAVA,  nil)
    flood_define_level(false, LEVEL_CTT,            "ctt",            { x =  0,     y = 700,   z =  0,    a =  0x0000 }, 5.0,  1,   FLOOD_LAVA,  nil)
    flood_define_level(true,  LEVEL_RR,             "rr",             { x =  0,     y = 3468,  z = -2335, a =  0x0000 }, 3.0,  1,   FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_CASTLE_GROUNDS, "castle-grounds", { x =  0,     y = 7583,  z = -4015, a =  0x0000 }, 5.0,  1,   FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_PSS,            "pss",            { x = -6381,  y = -4484, z = 5806,  a =  0x0000 }, -4.0, 1,   FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_CCM,            "ccm-slide",      { x = -6445,  y = -5836, z = -7158,  a =  0x0000 }, -4.0, 2,  FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_JRB,            "jrb",            { x =  4863,  y = 1889,  z = 703,   a =  0x0000 }, 1.0,  1,   FLOOD_SAND,  nil)
    flood_define_level(true,  LEVEL_JRB,            "jrb-ship",       { x =  16,  y = 1258,  z = 2964,   a =  0x0000 }, 2.0,  2,    FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_LLL,            "lll",            { x =  -21,  y = 768,  z = -6709,  a = -0x8000 }, 1.75,  1,   FLOOD_LAVA,  nil)
    flood_define_level(true,  LEVEL_SSL,            "ssl",            { x =  -5890,   y = 1024,  z = -2555,  a =  0x0000 }, 2.25, 1,FLOOD_SAND,  nil)
    flood_define_level(true,  LEVEL_DDD,            "ddd",            { x =  3945,  y = 571,   z = -1321, a =  0x0000 }, 3.0,  1,   FLOOD_SAND,  nil)
    flood_define_level(true,  LEVEL_BITFS,          "bitfs",          { x =  6723,  y = 2899,  z = 117,   a =  0x0000 }, 2.0,  1,   FLOOD_LAVA,  nil)
    flood_define_level(true,  LEVEL_THI,            "thi-w8rc",       { x = -1826,    y = 1434,  z = 1645, a =  0x0000 }, 7.0,  3,  FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_THI,            "thi-small",      { x = -2,    y = 1167,  z = -467, a =  0x0000 }, 5.5,  2,     FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_TOTWC,          "wing",           { x = -4000,  y = 2000,  z = 3970,  a =  0x8000 }, 3.0,  1,   FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_COTMC,          "metal",          { x = -13,    y = 374,   z = -6136, a =  0x0000 }, 4.0,  1,   FLOOD_WATER, nil)
    flood_define_level(true,  LEVEL_VCUTM,          "vcutm",          { x = -6170,  y = 5734,  z = -6163, a =  0x0000 }, 17.0, 1,   FLOOD_WATER, { x = 4272, y = -0, z = -4742, a = 0x8000 })
    flood_define_level(true,  LEVEL_WMOTR,          "fcs",            { x = -3357,  y = 4089,  z = -8437, a =  0x0000 }, 4.0,  1,   FLOOD_WATER, { x = 83, y = -1345, z = -59, a = -0x4000 })
    flood_define_level(true,  LEVEL_MC,             "mc",             { x = -3384,  y = 3700,  z = -7421, a =  0x0000 }, 4.5,  1,   FLOOD_WATER, { x = 90, y = 10, z = 24, a = 0x8000 })
    flood_define_level(true,  LEVEL_SL,             "up",             { x = -1438,  y = 10957, z =  -77,  a =  0x0000 }, 4.35, 1,   FLOOD_WATER, { x = 2322, y = -652, z = 8970, a = 0x8000 })
    flood_define_level(true,  LEVEL_CS,             "cs",             { x =  4307,  y = -6703, z = -415,  a =  0x0000 }, -5.0, 1,   FLOOD_WATER, { x = 5600, y = 6400, z = -3445, a = 0x8000 })
    flood_define_level(true,  LEVEL_CONSTRUCT,      "construct",      { x = -468,   y = 5536,  z = 7955,  a =  0x0000 }, 3.15, 1,   FLOOD_WATER, { x = -5177, y = -635, z = -10277, a = 0x8000 })
    flood_define_level(true,  LEVEL_BIRDSLAIR,      "birdslair",      { x = 671,   y = 1558,  z = 2108,  a =  0x0000 }, 4.5, 1,     FLOOD_WATER, nil)
end

local function flood_load_star_road_levels()
    game = GAME_STAR_ROAD

    --                 bonus  level                 name              goal position                                     speed area type         custom start pos
    flood_define_level(false, LEVEL_BOB,            "bob",            { x =  5364, y = 1875,  z =  2251, a =  0x0000 }, 3.0,  1,   FLOOD_WATER, nil) --
    flood_define_level(false, LEVEL_WF,             "wf",             { x =  208,  y = 2448,  z = -2080, a =  0x4000 }, 5.0,  1,   FLOOD_WATER, nil) --
    flood_define_level(false, LEVEL_CCM,            "ccm",            { x =  5709, y = 3501,  z = -2141, a = -0x4000 }, 3.0,  1,   FLOOD_WATER, nil) --
    flood_define_level(false, LEVEL_BITDW,          "bitdw",          { x =  455,  y = 2324,  z =  -4537,    a = -0x4000 }, 3.0,  1,   FLOOD_MUD,   nil) --
    flood_define_level(false, LEVEL_BBH,            "bbh",            { x =  4405,   y = 2632,  z =  244,  a =  0x8000 }, 3.0,  1,   FLOOD_WATER, nil) --
    flood_define_level(false, LEVEL_HMC,            "hmc",            { x = 2468,  y = 4160,  z = -5054, a =  0x0000 }, 5.0,  1,   FLOOD_WATER, { x = 4292, y = 2974, z = 4697, a = 0x8000}) -- 0.75x, 4405, 2632, -4537 no base
    flood_define_level(false, LEVEL_WDW,            "wdw",            { x =  1467,  y = 4096,  z =  93,   a = -0x4000 }, 4.0,  1,   FLOOD_WATER, nil) -- messed up -3465, 2603, 879
    flood_define_level(false, LEVEL_TTM,            "ttm",            { x =  176,  y = 2719,  z =  -1194,  a =  0x0000 }, 3.0,  1,   FLOOD_WATER, nil) -- flag needs no base
    flood_define_level(false, LEVEL_THI,            "thi",            { x =  1801,    y = 2879,  z = 4944, a =  0x0000 }, 4.0,  1,   FLOOD_LAVA, { x = -3815, y = -1070, z = 6646, a = 0x8000}) -- needs lava
    flood_define_level(false, LEVEL_TTC,            "ttc",            { x =  1660,  y = 3425,  z =  1992, a =  0x0000 }, 4.0,  1,   FLOOD_WATER, nil) -- 1660, 3425, 1992
    flood_define_level(false, LEVEL_BITS,           "bits",           { x =  1861,   y = 4192,  z = 841, a =  0x0000 }, 3.5,  1,   FLOOD_LAVA,  nil) -- 0.75x, 1861, 4192, 841
    flood_define_level(false, LEVEL_CTT,            "ctt",            { x =  0,     y = 700,   z =  0,    a =  0x0000 }, 5.0,  1,   FLOOD_LAVA,  nil) --
    flood_define_level(false,  LEVEL_RR,             "rr",             { x =  -2668,     y = 6684,  z = 7122, a =  0x0000 }, 4.5,  1,   FLOOD_WATER, nil) -- 1.5x
    flood_define_level(false,  LEVEL_CASTLE_GROUNDS, "castle-grounds", { x =  0,     y = 7583,  z = -4015, a =  0x0000 }, .0,  1,   FLOOD_WATER, nil) --
    flood_define_level(false, LEVEL_PSS,            "pss",            { x = -3415, y = 4573,  z =  2678, a =  0x0000 }, 3.0,  1,   FLOOD_WATER, nil)
    flood_define_level(false,  LEVEL_JRB,            "jrb",            { x =  -4653,  y = 3541,  z = -3616,   a =  0x0000 }, 1.0,  1,   FLOOD_SAND,  nil) -- -4653, 3541, -3616
    flood_define_level(false,  LEVEL_LLL,            "lll",            { x =  4315,  y = 4638,  z = 3963,  a = -0x8000 }, 7,  1,   FLOOD_LAVA,  nil) -- 4.5x
    flood_define_level(false,  LEVEL_SSL,            "ssl",            { x =  -3756,   y = -751,  z = 1514,  a =  0x0000 }, 5.75, 1, FLOOD_SAND,  { x = 4361, y = -931, z = -4430, a = 0x8000}) -- 2.6x
    flood_define_level(false,  LEVEL_DDD,            "ddd",            { x =  598,  y = 2232,   z = -3389, a =  0x0000 }, 6.0,  1,   FLOOD_SAND,  { x = -1323, y = -2299, z = 4482, a = 0x8000}) -- 2x
    flood_define_level(false,  LEVEL_BITFS,          "bitfs",          { x =  3010,  y = 584,  z = 4469,   a =  0x0000 }, 1.6,  1,   FLOOD_LAVA,  nil) -- 0.8x, 3010, 584, 4469
    flood_define_level(false,  LEVEL_TOTWC,          "wing",           { x = -4212,  y = 4229,  z = -4488,  a =  0x8000 }, 5.0,  1,   FLOOD_WATER, nil) -- 2x (also messed up) -4212, 4229, -4488
    flood_define_level(false,  LEVEL_COTMC,          "metal",          { x = 4078,    y = 5324,   z = -327, a =  0x0000 }, -4.0,  1,   FLOOD_WATER, nil) --
    flood_define_level(true,  LEVEL_WMOTR,          "fcs",            { x = -3357,  y = 4089,  z = -8437, a =  0x0000 }, 4.0,  1,   FLOOD_WATER, { x = 83, y = -1345, z = -59, a = -0x4000 }) --
    flood_define_level(true,  LEVEL_MC,             "mc",             { x = -3384,  y = 3700,  z = -7421, a =  0x0000 }, 4.5,  1,   FLOOD_WATER, { x = 90, y = 10, z = 24, a = 0x8000 }) --
    flood_define_level(true,  LEVEL_SL,             "up",             { x = -1438,  y = 10957, z =  -77,  a =  0x0000 }, 4.35, 1,   FLOOD_WATER, { x = 2322, y = -652, z = 8970, a = 0x8000 }) --
    flood_define_level(true,  LEVEL_CS,             "cs",             { x =  4307,  y = -6703, z = -415,  a =  0x0000 }, -5.0, 1,   FLOOD_WATER, { x = 5600, y = 6400, z = -3445, a = 0x8000 }) --
    flood_define_level(true,  LEVEL_CONSTRUCT,      "construct",      { x = -468,   y = 5536,  z = 7955,  a =  0x0000 }, 3.15, 1,   FLOOD_WATER, { x = -5177, y = -635, z = -10277, a = 0x8000 }) --
    flood_define_level(true,  LEVEL_BIRDSLAIR,      "birdslair",      { x = 671,   y = 1558,  z = 2108,  a =  0x0000 }, 4.5, 1,     FLOOD_WATER, nil) --
end

-- load romhack levels
for mod in pairs(gActiveMods) do
    if gActiveMods[mod].incompatible ~= nil and gActiveMods[mod].incompatible:find("romhack") then
        if gActiveMods[mod].relativePath == "star-road" then
            flood_load_star_road_levels()
        else
            unsupported = true
            djui_popup_create("\\#ff0000\\This rom hack is not supported with Flood.", 2)
        end
        break
    end
end

if not unsupported and game == GAME_VANILLA then
    flood_load_vanilla_levels()
end